"use client";
"use client;";
import React__default, { useState, useRef, useEffect } from "react";
import { Element } from "../Element/Element.js";
import { Div } from "../Element/Tags.js";
import { u as useClickOutside } from "../../UseClickOutside-Cy7gG1w2.js";
var _excluded = ["children", "openWhen", "closeWhen", "closeOnClickOutside", "padding", "position", "size", "bgColor", "bgColour", "isDismissible", "showOverlay"];
function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}
function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}
function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];
  return arr2;
}
function _iterableToArrayLimit(r, l) {
  var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"];
  if (null != t) {
    var e, n, i, u, a = [], f = true, o = false;
    try {
      if (i = (t = t.call(r)).next, 0 === l) ;
      else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = true) ;
    } catch (r2) {
      o = true, n = r2;
    } finally {
      try {
        if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return;
      } finally {
        if (o) throw n;
      }
    }
    return a;
  }
}
function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}
function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};
  var target = _objectWithoutPropertiesLoose(source, excluded);
  var key, i;
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }
  return target;
}
function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }
  return target;
}
var Drawer = /* @__PURE__ */ React__default.forwardRef(function(_ref, ref) {
  var children = _ref.children, openWhen = _ref.openWhen, closeWhen = _ref.closeWhen, closeOnClickOutside = _ref.closeOnClickOutside, padding = _ref.padding, position = _ref.position, size = _ref.size, bgColor = _ref.bgColor, bgColour = _ref.bgColour, _ref$isDismissible = _ref.isDismissible, isDismissible = _ref$isDismissible === void 0 ? true : _ref$isDismissible, _ref$showOverlay = _ref.showOverlay, showOverlay = _ref$showOverlay === void 0 ? false : _ref$showOverlay, props = _objectWithoutProperties(_ref, _excluded);
  var _useState = useState(openWhen), _useState2 = _slicedToArray(_useState, 2), shouldRender = _useState2[0], setShouldRender = _useState2[1];
  var drawerRef = useRef(null);
  var effectiveRef = ref || drawerRef;
  useEffect(function() {
    if (openWhen) {
      setShouldRender(true);
    }
  }, [openWhen]);
  var onAnimationEnd = function onAnimationEnd2() {
    if (!openWhen) {
      setShouldRender(false);
    }
  };
  var classNames = ["drawer"];
  if (position) {
    classNames.push(position);
  }
  if (openWhen) {
    classNames.push("open");
  } else if (shouldRender) {
    classNames.push("close");
  }
  var closeDrawer = function closeDrawer2() {
    if (closeWhen) {
      closeWhen();
    }
  };
  useClickOutside(effectiveRef, closeOnClickOutside ? closeDrawer : function() {
  });
  if (size) {
    classNames.push(size);
  }
  return shouldRender ? /* @__PURE__ */ React__default.createElement(React__default.Fragment, null, /* @__PURE__ */ React__default.createElement(Element, _extends({
    as: "div",
    "data-drawer": true,
    ref: effectiveRef,
    classNames,
    onAnimationEnd
  }, closeOnClickOutside ? {
    onClick: closeDrawer
  } : {}, props), openWhen && showOverlay && /* @__PURE__ */ React__default.createElement(Div, {
    className: "rest-of-page-overlay ".concat(openWhen ? "visible" : "")
  }), /* @__PURE__ */ React__default.createElement(Element, {
    as: "div",
    className: "drawer-content-wrapper",
    padding,
    bgColor,
    bgColour
  }, isDismissible && /* @__PURE__ */ React__default.createElement("button", {
    className: "dismiss-button",
    onClick: closeDrawer
  }), children))) : null;
});
export {
  Drawer
};
