"use client";
"use client;";
import React__default from "react";
import { Element } from "../../Element/Element.js";
import { Div } from "../../Element/Tags.js";
import { InputLabel } from "../InputLabel/InputLabel.js";
import { FormItem } from "../FormItem/FormItem.js";
var _excluded = ["as", "className", "label", "helpText", "errorText", "iconLeft", "iconRight", "validateThis", "classNames"];
function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};
  var target = _objectWithoutPropertiesLoose(source, excluded);
  var key, i;
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }
  return target;
}
function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }
  return target;
}
var BaseInputComponent = /* @__PURE__ */ React__default.forwardRef(function(_ref, ref) {
  var Component = _ref.as, className = _ref.className, label = _ref.label, helpText = _ref.helpText, errorText = _ref.errorText, iconLeft = _ref.iconLeft, iconRight = _ref.iconRight, validateThis = _ref.validateThis, classNames = _ref.classNames, inputProps = _objectWithoutProperties(_ref, _excluded);
  return /* @__PURE__ */ React__default.createElement(FormItem, {
    "data-form-item": true,
    required: inputProps.required
  }, /* @__PURE__ */ React__default.createElement(Element, _extends({
    as: Component,
    ref,
    classNames: [className || "", iconLeft ? "with-icon-left" : "", iconRight ? "with-icon-right" : "", validateThis ? "validate-this" : ""].concat(classNames || [])
  }, inputProps)), iconLeft && /* @__PURE__ */ React__default.createElement(Element, {
    as: "span",
    className: "icon-left"
  }, iconLeft), iconRight && /* @__PURE__ */ React__default.createElement(Element, {
    as: "span",
    className: "icon-right"
  }, iconRight), label && /* @__PURE__ */ React__default.createElement(InputLabel, {
    label,
    htmlFor: inputProps.id
  }), (helpText || errorText) && /* @__PURE__ */ React__default.createElement(Div, {
    className: "info-section vertically-center-items",
    marginTop: "nano"
  }, helpText && /* @__PURE__ */ React__default.createElement(Element, {
    as: "span",
    className: "help-text"
  }, helpText), errorText && /* @__PURE__ */ React__default.createElement(Element, {
    as: "span",
    className: "error-text"
  }, errorText)));
});
export {
  BaseInputComponent
};
