"use client";
"use client;";
import React__default from "react";
import { Element } from "../../Element/Element.js";
import { Callout } from "../../Callout/Callout.js";
import { generateFormThroughConfig } from "./FormGenerator.js";
var _excluded = ["spacing", "fields", "onFieldsChange", "children", "errorText"];
function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};
  var target = _objectWithoutPropertiesLoose(source, excluded);
  var key, i;
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }
  return target;
}
function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }
  return target;
}
var Form = /* @__PURE__ */ React__default.forwardRef(function(_ref, ref) {
  var _ref$spacing = _ref.spacing, spacing = _ref$spacing === void 0 ? "small" : _ref$spacing, fields = _ref.fields, onFieldsChange = _ref.onFieldsChange, children = _ref.children, errorText = _ref.errorText, props = _objectWithoutProperties(_ref, _excluded);
  var classNames = [];
  if (spacing) {
    classNames.push("spacing-".concat(spacing));
  }
  if (fields && fields.length > 0) {
    children = [generateFormThroughConfig(fields, onFieldsChange, spacing), children];
  }
  return /* @__PURE__ */ React__default.createElement(Element, _extends({
    as: "form",
    "data-form": true,
    ref,
    classNames
  }, props), children, errorText && /* @__PURE__ */ React__default.createElement(Callout, {
    kind: "error"
  }, errorText));
});
export {
  Form
};
