"use client";
"use client;";
import React__default from "react";
import { Element } from "../../Element/Element.js";
import { Row } from "../../Row/Row.js";
import { Portion } from "../../Portion/Portion.js";
import { InputLabel } from "../InputLabel/InputLabel.js";
import { InputField } from "../InputField/InputField.js";
import { FileUpload } from "../InputField/FileUpload.js";
import { Checkbox } from "../Checkbox/Checkbox.js";
import { Switch } from "../Checkbox/Switch.js";
import { RadioButton } from "../RadioButton/RadioButton.js";
import { RadioGroup } from "../RadioButton/RadioGroup.js";
import { Select } from "../Select/Select.js";
import { TextArea } from "../TextArea/TextArea.js";
var _excluded = ["as"], _excluded2 = ["desktopSpan", "tabletLandscapeSpan", "tabletPortraitSpan", "mobileSpan", "isHorizontal"];
function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};
  var target = _objectWithoutPropertiesLoose(source, excluded);
  var key, i;
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }
  return target;
}
function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }
  return target;
}
var FormElements = {
  Checkbox,
  Switch,
  InputField,
  FileUpload,
  InputLabel,
  RadioButton,
  RadioGroup,
  Select,
  TextArea,
  Empty: "div"
};
var getFormItem = function getFormItem2(formField, onFieldsChange) {
  var elementName = formField.as, formFieldProps = _objectWithoutProperties(formField, _excluded);
  return /* @__PURE__ */ React__default.createElement(Element, _extends({
    as: FormElements[elementName] || InputField
  }, formFieldProps, {
    isFullWidth: true,
    onChange: onFieldsChange
  }));
};
var generateFormThroughConfig = function generateFormThroughConfig2(fields, onFieldsChange, spacing) {
  var formChildren = [];
  for (var i in fields) {
    var _fields$i = fields[i], desktopSpan = _fields$i.desktopSpan, tabletLandscapeSpan = _fields$i.tabletLandscapeSpan, tabletPortraitSpan = _fields$i.tabletPortraitSpan, mobileSpan = _fields$i.mobileSpan, isHorizontal = _fields$i.isHorizontal, formField = _objectWithoutProperties(_fields$i, _excluded2);
    var portionProps = {
      desktopSpan,
      tabletLandscapeSpan,
      tabletPortraitSpan,
      mobileSpan,
      isHorizontal
    };
    formChildren.push(/* @__PURE__ */ React__default.createElement(Portion, _extends({}, portionProps, {
      key: "fields-".concat(i)
    }), getFormItem(formField, onFieldsChange)));
  }
  return /* @__PURE__ */ React__default.createElement(Row, {
    gutters: spacing
  }, formChildren);
};
export {
  generateFormThroughConfig
};
