"use client";
"use client;";
import React__default, { useState, useRef, useEffect } from "react";
import { Div } from "../../Element/Tags.js";
import { InputField } from "../InputField/InputField.js";
import { Badge } from "../../Badge/Badge.js";
import { Text } from "../../Typography/Text.js";
import { BaseInputComponent } from "../BaseInputComponent/BaseInputComponent.js";
import { searchOptions } from "./listBoxUtils.js";
var _excluded = ["options", "label", "placeholder", "id", "allowMultiSelect", "onChange", "disabled", "badgeBgColour", "badgeBgColor", "badgeTextColour", "badgeTextColor", "selectionLimit", "allowCustomEntries"];
function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}
function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
}
function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}
function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}
function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}
function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];
  return arr2;
}
function _iterableToArrayLimit(r, l) {
  var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"];
  if (null != t) {
    var e, n, i, u, a = [], f = true, o = false;
    try {
      if (i = (t = t.call(r)).next, 0 === l) ;
      else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = true) ;
    } catch (r2) {
      o = true, n = r2;
    } finally {
      try {
        if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return;
      } finally {
        if (o) throw n;
      }
    }
    return a;
  }
}
function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}
function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};
  var target = _objectWithoutPropertiesLoose(source, excluded);
  var key, i;
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }
  return target;
}
function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }
  return target;
}
var ListBox = /* @__PURE__ */ React__default.forwardRef(function(_ref, ref) {
  var options = _ref.options, label = _ref.label, _ref$placeholder = _ref.placeholder, placeholder = _ref$placeholder === void 0 ? "Select an option" : _ref$placeholder, id = _ref.id, _ref$allowMultiSelect = _ref.allowMultiSelect, allowMultiSelect = _ref$allowMultiSelect === void 0 ? false : _ref$allowMultiSelect, onChange = _ref.onChange, disabled = _ref.disabled, badgeBgColour = _ref.badgeBgColour, badgeBgColor = _ref.badgeBgColor, badgeTextColour = _ref.badgeTextColour, badgeTextColor = _ref.badgeTextColor, selectionLimit = _ref.selectionLimit, _ref$allowCustomEntri = _ref.allowCustomEntries, allowCustomEntries = _ref$allowCustomEntri === void 0 ? false : _ref$allowCustomEntri, props = _objectWithoutProperties(_ref, _excluded);
  var _useState = useState(false), _useState2 = _slicedToArray(_useState, 2), isOpen = _useState2[0], setIsOpen = _useState2[1];
  var _useState3 = useState(null), _useState4 = _slicedToArray(_useState3, 2), selectedOption = _useState4[0], setSelectedOption = _useState4[1];
  var _useState5 = useState([]), _useState6 = _slicedToArray(_useState5, 2), selectedOptions = _useState6[0], setSelectedOptions = _useState6[1];
  var _useState7 = useState(""), _useState8 = _slicedToArray(_useState7, 2), searchValue = _useState8[0], setSearchValue = _useState8[1];
  var _useState9 = useState(-1), _useState10 = _slicedToArray(_useState9, 2), activeIndex = _useState10[0], setActiveIndex = _useState10[1];
  var dropdownRef = useRef();
  var searchInputRef = useRef(null);
  var effectiveRef = ref || dropdownRef;
  var filteredOptions = searchOptions(options, searchValue);
  var handleSelectOption = function handleSelectOption2(option) {
    if (option.disabled) return;
    var newSelectedOptions;
    if (allowMultiSelect) {
      var isSelected = selectedOptions.some(function(opt) {
        return opt.value === option.value;
      });
      if (isSelected) {
        newSelectedOptions = selectedOptions.filter(function(opt) {
          return opt.value !== option.value;
        });
      } else {
        if (selectionLimit && selectedOptions.length >= selectionLimit) {
          return;
        }
        newSelectedOptions = [].concat(_toConsumableArray(selectedOptions), [option]);
      }
      setSelectedOptions(newSelectedOptions);
      onChange === null || onChange === void 0 || onChange(newSelectedOptions.map(function(opt) {
        return opt.value;
      }));
      setSearchValue("");
      setActiveIndex(-1);
    } else {
      newSelectedOptions = [option];
      setSelectedOption(option);
      setSelectedOptions(newSelectedOptions);
      onChange === null || onChange === void 0 || onChange(option.value);
      setIsOpen(false);
      setSearchValue("");
      setActiveIndex(-1);
    }
  };
  var handleDeleteOption = function handleDeleteOption2(e, valueToRemove) {
    e.stopPropagation();
    var newSelectedOptions = selectedOptions.filter(function(opt) {
      return opt.value !== valueToRemove;
    });
    setSelectedOptions(newSelectedOptions);
    onChange === null || onChange === void 0 || onChange(newSelectedOptions.map(function(opt) {
      return opt.value;
    }));
  };
  var handleCustomEntry = function handleCustomEntry2() {
    if (!searchValue.trim() || !allowCustomEntries) return;
    var customOption = {
      value: searchValue.trim(),
      label: searchValue.trim()
    };
    handleSelectOption(customOption);
    setSearchValue("");
    setActiveIndex(-1);
  };
  var handleClearAll = function handleClearAll2(e) {
    e.stopPropagation();
    setSelectedOptions([]);
    onChange === null || onChange === void 0 || onChange([]);
  };
  var handleKeyDown = function handleKeyDown2(event) {
    switch (event.key) {
      case "ArrowDown":
        event.preventDefault();
        if (!isOpen) {
          setIsOpen(true);
          setActiveIndex(0);
        } else {
          setActiveIndex(function(prev) {
            return prev < filteredOptions.length - 1 ? prev + 1 : prev;
          });
        }
        break;
      case "ArrowUp":
        event.preventDefault();
        setActiveIndex(function(prev) {
          return prev > 0 ? prev - 1 : prev;
        });
        break;
      case "Enter":
        event.preventDefault();
        if (allowCustomEntries && searchValue.trim()) {
          var exactMatch = filteredOptions.find(function(opt) {
            return opt.label.toLowerCase() === searchValue.trim().toLowerCase();
          });
          if (exactMatch) {
            handleSelectOption(exactMatch);
          } else {
            handleCustomEntry();
          }
        } else if (activeIndex >= 0 && filteredOptions[activeIndex]) {
          handleSelectOption(filteredOptions[activeIndex]);
        }
        break;
      case "Escape":
        event.preventDefault();
        setIsOpen(false);
        setActiveIndex(-1);
        break;
      case " ":
        if (!isOpen) {
          event.preventDefault();
          setIsOpen(true);
          setActiveIndex(0);
        }
        break;
      case "Home":
        if (isOpen) {
          event.preventDefault();
          setActiveIndex(0);
        }
        break;
      case "End":
        if (isOpen) {
          event.preventDefault();
          setActiveIndex(filteredOptions.length - 1);
        }
        break;
    }
  };
  useEffect(function() {
    var handleClickOutside = function handleClickOutside2(event) {
      if (effectiveRef.current && !effectiveRef.current.contains(event.target)) {
        setIsOpen(false);
        setActiveIndex(-1);
      }
    };
    document.addEventListener("mousedown", handleClickOutside);
    return function() {
      return document.removeEventListener("mousedown", handleClickOutside);
    };
  }, []);
  useEffect(function() {
    if (isOpen && searchInputRef.current) {
      searchInputRef.current.focus();
    }
  }, [isOpen]);
  useEffect(function() {
    if (activeIndex >= 0) {
      var activeOption = document.querySelector('[data-index="'.concat(activeIndex, '"]'));
      activeOption === null || activeOption === void 0 || activeOption.scrollIntoView({
        block: "nearest"
      });
    }
  }, [activeIndex]);
  return /* @__PURE__ */ React__default.createElement(BaseInputComponent, _extends({
    "data-list-box": true,
    className: "list-box-wrapper ".concat(disabled ? "disabled" : ""),
    "aria-disabled": disabled,
    ref: effectiveRef
  }, props), label && /* @__PURE__ */ React__default.createElement("label", {
    id: "".concat(id, "-label"),
    htmlFor: "".concat(id, "-listbox"),
    className: "list-box-label"
  }, label), /* @__PURE__ */ React__default.createElement(Div, {
    className: "list-box-input-wrapper",
    onClick: function onClick() {
      return !disabled && allowMultiSelect ? setIsOpen(!isOpen) : setIsOpen(!isOpen);
    },
    onKeyDown: handleKeyDown,
    "aria-haspopup": "listbox",
    "aria-expanded": isOpen,
    "aria-labelledby": label ? "".concat(id, "-label") : void 0,
    "aria-controls": isOpen ? "".concat(id, "-listbox") : void 0
  }, allowMultiSelect ? /* @__PURE__ */ React__default.createElement(React__default.Fragment, null, selectedOptions.length > 0 ? /* @__PURE__ */ React__default.createElement(Div, {
    className: "options-wrapper"
  }, /* @__PURE__ */ React__default.createElement(Div, {
    className: "options-list"
  }, selectedOptions.map(function(option) {
    return /* @__PURE__ */ React__default.createElement(Badge, {
      key: option.value,
      withDelete: allowMultiSelect,
      onDelete: function onDelete(e) {
        return handleDeleteOption(e, option.value);
      },
      size: "small",
      shape: "rounded",
      bgColour: badgeBgColour || badgeBgColor,
      textColour: badgeTextColour || badgeTextColor
    }, option.label);
  })), selectionLimit && selectedOptions.length >= selectionLimit && /* @__PURE__ */ React__default.createElement(Text, {
    className: "options-limit-warning",
    textColour: "red",
    size: "small"
  }, "You can choose only ", selectionLimit, " option", selectionLimit === 1 ? "" : "s")) : /* @__PURE__ */ React__default.createElement("span", {
    className: "placeholder"
  }, placeholder), selectedOptions.length > 0 && /* @__PURE__ */ React__default.createElement(Div, {
    className: "icon-wrapper clear-all",
    title: "Clear all options",
    onClick: handleClearAll
  }, /* @__PURE__ */ React__default.createElement("svg", {
    viewBox: "0 0 24 24"
  }, /* @__PURE__ */ React__default.createElement("line", {
    x1: "5",
    y1: "5",
    x2: "19",
    y2: "19"
  }), /* @__PURE__ */ React__default.createElement("line", {
    x1: "5",
    y1: "19",
    x2: "19",
    y2: "5"
  })))) : (
    // FOR PLAIN TEXT SINGLE-SELECT OPTION =========================================================
    selectedOption ? /* @__PURE__ */ React__default.createElement(Text, {
      className: "selected-option"
    }, selectedOption.label) : /* @__PURE__ */ React__default.createElement("span", {
      className: "placeholder"
    }, placeholder)
  ), /* @__PURE__ */ React__default.createElement(Div, {
    className: "icon-wrapper chevrons"
  }, /* @__PURE__ */ React__default.createElement("svg", {
    viewBox: "0 0 24 24"
  }, /* @__PURE__ */ React__default.createElement("polyline", {
    points: "6 9 12 4 18 9"
  }), /* @__PURE__ */ React__default.createElement("polyline", {
    points: "6 15 12 20 18 15"
  })))), isOpen && !disabled && /* @__PURE__ */ React__default.createElement(Div, {
    className: "list-box-dropdown",
    role: "presentation"
  }, /* @__PURE__ */ React__default.createElement(Div, {
    className: "list-box-search-wrapper"
  }, /* @__PURE__ */ React__default.createElement(InputField, {
    type: "text",
    ref: searchInputRef,
    className: "list-box-search",
    placeholder: "Search",
    value: searchValue,
    onChange: function onChange2(e) {
      setSearchValue(e.target.value);
    },
    onKeyDown: handleKeyDown,
    "aria-controls": "".concat(id, "-listbox")
  }), allowCustomEntries && searchValue.trim() && !selectedOptions.some(function(opt) {
    return opt.label.toLowerCase() === searchValue.trim().toLowerCase();
  }) && /* @__PURE__ */ React__default.createElement("kbd", {
    className: "list-box-enter-key"
  }, "↵")), /* @__PURE__ */ React__default.createElement("ul", {
    id: "".concat(id, "-listbox"),
    className: "list-box-options",
    role: "listbox",
    "aria-label": label || "Select options",
    tabIndex: -1
  }, filteredOptions.length > 0 ? filteredOptions.map(function(option, index) {
    return /* @__PURE__ */ React__default.createElement("li", {
      key: option.value,
      id: "".concat(id, "-option-").concat(option.value),
      className: "list-box-option ".concat(option.disabled ? "disabled" : "", " ").concat(activeIndex === index ? "active" : ""),
      role: "option",
      "aria-selected": selectedOptions.some(function(opt) {
        return opt.value === option.value;
      }),
      "aria-disabled": option.disabled,
      onClick: function onClick() {
        return handleSelectOption(option);
      },
      "data-index": index
    }, option.customLabel || option.label);
  }) : /* @__PURE__ */ React__default.createElement("li", {
    className: "list-box-option disabled",
    role: "alert"
  }, "No matches found"))));
});
export {
  ListBox
};
