"use client";
"use client;";
var levenshteinDistance = function levenshteinDistance2(a, b) {
  var matrix = [];
  var aLength = a.length;
  var bLength = b.length;
  if (aLength === 0) return bLength;
  if (bLength === 0) return aLength;
  for (var i = 0; i <= bLength; i++) {
    matrix[i] = [i];
  }
  for (var j = 0; j <= aLength; j++) {
    matrix[0][j] = j;
  }
  for (var _i = 1; _i <= bLength; _i++) {
    for (var _j = 1; _j <= aLength; _j++) {
      if (b[_i - 1] === a[_j - 1]) {
        matrix[_i][_j] = matrix[_i - 1][_j - 1];
      } else {
        matrix[_i][_j] = Math.min(
          matrix[_i - 1][_j] + 1,
          // Deletion
          matrix[_i][_j - 1] + 1,
          // Insertion
          matrix[_i - 1][_j - 1] + 1
          // Substitution
        );
      }
    }
  }
  return matrix[bLength][aLength];
};
var isSubsequence = function isSubsequence2(search, target) {
  var searchIndex = 0;
  var targetIndex = 0;
  while (searchIndex < search.length && targetIndex < target.length) {
    if (search[searchIndex] === target[targetIndex]) {
      searchIndex++;
    }
    targetIndex++;
  }
  return searchIndex === search.length;
};
var generateAcronym = function generateAcronym2(label) {
  return label.split(/[\s\-_]+/).map(function(word) {
    return word.slice(0, 2);
  }).join("").toLowerCase();
};
var searchOptions = function searchOptions2(options, searchTerm) {
  if (!searchTerm) return options;
  var normalizedSearch = searchTerm.toLowerCase().trim();
  var maxDistance = Math.floor(normalizedSearch.length / 2);
  var matchedOptions = options.map(function(option) {
    var normalizedLabel = option.label.toLowerCase();
    var distance = levenshteinDistance(normalizedSearch, normalizedLabel);
    var words = normalizedLabel.split(/[\s\-_]+/);
    var searchWords = normalizedSearch.split(/[\s\-_]+/);
    var isPartialMatch = normalizedLabel.includes(normalizedSearch) || searchWords.every(function(searchWord) {
      return words.some(function(word) {
        return word.startsWith(searchWord);
      });
    });
    var acronym = generateAcronym(normalizedLabel);
    var isAcronymMatch = isSubsequence(normalizedSearch, acronym);
    return {
      option,
      distance,
      isPartialMatch,
      isAcronymMatch
    };
  }).filter(function(_ref) {
    var distance = _ref.distance, isPartialMatch = _ref.isPartialMatch, isAcronymMatch = _ref.isAcronymMatch;
    return isPartialMatch || isAcronymMatch || distance <= maxDistance;
  }).sort(function(a, b) {
    if (a.isPartialMatch && !b.isPartialMatch) return -1;
    if (!a.isPartialMatch && b.isPartialMatch) return 1;
    if (a.isAcronymMatch && !b.isAcronymMatch) return -1;
    if (!a.isAcronymMatch && b.isAcronymMatch) return 1;
    return a.distance - b.distance;
  }).map(function(_ref2) {
    var option = _ref2.option;
    return option;
  });
  return matchedOptions;
};
export {
  generateAcronym,
  isSubsequence,
  levenshteinDistance,
  searchOptions
};
