"use client";
"use client;";
import React__default from "react";
import { Element } from "../Element/Element.js";
import { Text } from "../Typography/Text.js";
var _excluded = ["label", "value", "height", "suffix", "showOptimumMarker"];
function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};
  var target = _objectWithoutPropertiesLoose(source, excluded);
  var key, i;
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }
  return target;
}
function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }
  return target;
}
var Meter = /* @__PURE__ */ React__default.forwardRef(function(_ref, ref) {
  var label = _ref.label, value = _ref.value, height = _ref.height, suffix = _ref.suffix, showOptimumMarker = _ref.showOptimumMarker, props = _objectWithoutProperties(_ref, _excluded);
  var optimumPositionPercent = (props.optimum ? props.optimum : 0 - props.min) / (props.max - props.min) * 100;
  return /* @__PURE__ */ React__default.createElement(React__default.Fragment, null, label && /* @__PURE__ */ React__default.createElement(Element, {
    as: "div",
    "data-meter-meta": true
  }, /* @__PURE__ */ React__default.createElement(Text, null, label), /* @__PURE__ */ React__default.createElement(Text, null, value, suffix && suffix)), /* @__PURE__ */ React__default.createElement("div", {
    className: "meter-wrapper"
  }, /* @__PURE__ */ React__default.createElement(Element, _extends({
    as: "meter",
    "data-meter": true,
    ref,
    value
  }, props, {
    title: suffix,
    style: {
      height
    }
  })), showOptimumMarker && /* @__PURE__ */ React__default.createElement("div", {
    className: "optimum-marker",
    style: {
      left: "calc(".concat(optimumPositionPercent, "% - var(--meter-border-width))")
    },
    title: "Optimum: ".concat(props.optimum)
  })));
});
export {
  Meter
};
