"use client";
"use client;";
import React__default from "react";
import { Element } from "../Element/Element.js";
import { Text } from "../Typography/Text.js";
var _excluded = ["id", "children", "classNames", "isDismissible", "showBackdrop", "blurBackdrop"];
function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};
  var target = _objectWithoutPropertiesLoose(source, excluded);
  var key, i;
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }
  return target;
}
function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }
  return target;
}
var Modal = /* @__PURE__ */ React__default.forwardRef(function(_ref, ref) {
  var id = _ref.id, children = _ref.children, _ref$classNames = _ref.classNames, classNames = _ref$classNames === void 0 ? [] : _ref$classNames, isDismissible = _ref.isDismissible, showBackdrop = _ref.showBackdrop, blurBackdrop = _ref.blurBackdrop, props = _objectWithoutProperties(_ref, _excluded);
  if (showBackdrop) {
    classNames.push("show-backdrop");
  }
  if (blurBackdrop) {
    classNames.push("blur-backdrop");
  }
  return /* @__PURE__ */ React__default.createElement(Element, _extends({
    as: "div",
    id,
    "data-modal": true,
    popover: isDismissible ? "auto" : "manual",
    ref,
    classNames
  }, props), isDismissible && /* @__PURE__ */ React__default.createElement(Text, {
    className: "dismiss-button",
    onClick: function onClick() {
      return hideModal(id);
    }
  }, "×"), children);
});
var showModal = function showModal2(modalId) {
  var modal = document.querySelector("#".concat(modalId, "[data-modal]"));
  if (modal instanceof HTMLElement) {
    modal.showPopover();
  }
};
var hideModal = function hideModal2(modalId) {
  var modal = document.querySelector("#".concat(modalId, "[data-modal]"));
  if (modal instanceof HTMLElement) {
    modal.hidePopover();
  }
};
var toggleModal = function toggleModal2(modalId) {
  var modal = document.querySelector("#".concat(modalId, "[data-modal]"));
  if (modal instanceof HTMLElement) {
    modal.matches(":popover-open") ? modal.hidePopover() : modal.showPopover();
  }
};
export {
  Modal,
  hideModal,
  showModal,
  toggleModal
};
