import React, { ReactNode } from "react";
import { CardProps } from "../Card/Card";
export type TickPosition = "top-left" | "top-right" | "bottom-left" | "bottom-right" | "centre-left" | "center-left" | "centre-right" | "center-right" | "centre-top" | "center-top" | "center-bottom" | "centre-bottom" | "centre" | "center";
export interface OptionCardsProviderProps {
    children: ReactNode;
    allowMultipleSelections?: boolean;
    showTickIcon?: boolean;
    tickPosition?: TickPosition;
    onSelectionChange?: (selectedIds: Set<string>) => void;
}
export interface OptionCardProps extends CardProps {
    id: string;
    children: ReactNode;
    disabled?: boolean;
}
export declare const OptionCardsGroup: React.FC<OptionCardsProviderProps>;
export declare const useOptionCard: (id: string) => {
    isSelected: boolean;
    toggleSelection: () => void;
    showTickIcon: boolean | undefined;
};
export declare const OptionCard: React.FC<OptionCardProps>;
