"use client";
"use client;";
import React__default, { useState, useCallback, useContext, createContext } from "react";
import { Element } from "../Element/Element.js";
import { Card } from "../Card/Card.js";
var _excluded = ["children", "allowMultipleSelections", "showTickIcon", "onSelectionChange", "tickPosition"], _excluded2 = ["id", "children", "disabled"];
function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}
function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}
function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];
  return arr2;
}
function _iterableToArrayLimit(r, l) {
  var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"];
  if (null != t) {
    var e, n, i, u, a = [], f = true, o = false;
    try {
      if (i = (t = t.call(r)).next, 0 === l) ;
      else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = true) ;
    } catch (r2) {
      o = true, n = r2;
    } finally {
      try {
        if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return;
      } finally {
        if (o) throw n;
      }
    }
    return a;
  }
}
function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}
function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};
  var target = _objectWithoutPropertiesLoose(source, excluded);
  var key, i;
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }
  return target;
}
function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }
  return target;
}
var OptionCardsContext = /* @__PURE__ */ createContext({
  isSelected: function isSelected() {
    return false;
  },
  toggleSelection: function toggleSelection() {
  },
  showTickIcon: false,
  tickPosition: "top-right"
});
var OptionCardsGroup = function OptionCardsGroup2(_ref) {
  var children = _ref.children, _ref$allowMultipleSel = _ref.allowMultipleSelections, allowMultipleSelections = _ref$allowMultipleSel === void 0 ? false : _ref$allowMultipleSel, showTickIcon = _ref.showTickIcon, onSelectionChange = _ref.onSelectionChange, _ref$tickPosition = _ref.tickPosition, tickPosition = _ref$tickPosition === void 0 ? "top-right" : _ref$tickPosition;
  _objectWithoutProperties(_ref, _excluded);
  var _useState = useState(/* @__PURE__ */ new Set()), _useState2 = _slicedToArray(_useState, 2), selectedIds = _useState2[0], setSelectedIds = _useState2[1];
  var toggleSelection2 = useCallback(function(id) {
    setSelectedIds(function(prevSelectedIds) {
      var newSelectedIds = new Set(prevSelectedIds);
      if (allowMultipleSelections) {
        if (newSelectedIds.has(id)) {
          newSelectedIds["delete"](id);
        } else {
          newSelectedIds.add(id);
        }
      } else {
        if (newSelectedIds.has(id) && prevSelectedIds.size === 1) {
          newSelectedIds.clear();
        } else {
          newSelectedIds.clear();
          newSelectedIds.add(id);
        }
      }
      onSelectionChange === null || onSelectionChange === void 0 || onSelectionChange(newSelectedIds);
      return newSelectedIds;
    });
  }, [allowMultipleSelections, onSelectionChange]);
  var isSelected2 = useCallback(function(id) {
    return selectedIds.has(id);
  }, [selectedIds]);
  return /* @__PURE__ */ React__default.createElement(OptionCardsContext.Provider, {
    value: {
      isSelected: isSelected2,
      toggleSelection: toggleSelection2,
      showTickIcon,
      tickPosition
    }
  }, /* @__PURE__ */ React__default.createElement("div", {
    "data-option-cards-group": true,
    className: "tick-".concat(tickPosition)
  }, children));
};
var useOptionCard = function useOptionCard2(id) {
  var context = useContext(OptionCardsContext);
  return {
    isSelected: context.isSelected(id),
    toggleSelection: function toggleSelection2() {
      return context.toggleSelection(id);
    },
    showTickIcon: context.showTickIcon
  };
};
var OptionCard = function OptionCard2(_ref2) {
  var id = _ref2.id, children = _ref2.children, _ref2$disabled = _ref2.disabled, disabled = _ref2$disabled === void 0 ? false : _ref2$disabled, props = _objectWithoutProperties(_ref2, _excluded2);
  var _useOptionCard = useOptionCard(id), isSelected2 = _useOptionCard.isSelected, toggleSelection2 = _useOptionCard.toggleSelection, showTickIcon = _useOptionCard.showTickIcon;
  var _useState3 = useState(false), _useState4 = _slicedToArray(_useState3, 2), showDeselect = _useState4[0], setShowDeselect = _useState4[1];
  var _useState5 = useState(true), _useState6 = _slicedToArray(_useState5, 2), isInitialHover = _useState6[0], setIsInitialHover = _useState6[1];
  var classNames = [];
  if (isSelected2) {
    classNames.push("selected");
  }
  if (disabled) {
    classNames.push("disabled");
  }
  if (showDeselect) {
    classNames.push("show-deselect");
  }
  var handleMouseEnter = function handleMouseEnter2() {
    if (isSelected2 && !isInitialHover) {
      setShowDeselect(true);
    }
  };
  var handleMouseLeave = function handleMouseLeave2() {
    setShowDeselect(false);
    setIsInitialHover(false);
  };
  var handleClick = function handleClick2(e) {
    if (!disabled) {
      var _props$onClick;
      setIsInitialHover(true);
      setShowDeselect(false);
      toggleSelection2();
      (_props$onClick = props.onClick) === null || _props$onClick === void 0 || _props$onClick.call(props, e);
    }
  };
  var handleKeyDown = function handleKeyDown2(e) {
    if ((e.key === "Enter" || e.key === " ") && !disabled) {
      e.preventDefault();
      setIsInitialHover(true);
      setShowDeselect(false);
      toggleSelection2();
    }
  };
  return /* @__PURE__ */ React__default.createElement(Element, _extends({
    as: Card,
    "data-option-card": true,
    role: "button",
    tabIndex: disabled ? -1 : 0,
    "aria-disabled": disabled ? "true" : "false",
    "aria-selected": isSelected2 ? "true" : "false",
    classNames,
    onClick: handleClick,
    onKeyDown: handleKeyDown,
    onMouseEnter: handleMouseEnter,
    onMouseLeave: handleMouseLeave
  }, props), showTickIcon && /* @__PURE__ */ React__default.createElement(React__default.Fragment, null, /* @__PURE__ */ React__default.createElement("svg", {
    viewBox: "0 0 24 24",
    className: "tick-icon"
  }, /* @__PURE__ */ React__default.createElement("circle", {
    cx: "12",
    cy: "12",
    r: "11"
  }), /* @__PURE__ */ React__default.createElement("path", {
    d: "M8 13 L11 15 L16 9"
  })), /* @__PURE__ */ React__default.createElement("svg", {
    viewBox: "0 0 24 24",
    className: "deselect-icon"
  }, /* @__PURE__ */ React__default.createElement("circle", {
    cx: "12",
    cy: "12",
    r: "11"
  }), /* @__PURE__ */ React__default.createElement("path", {
    d: "M8 8 L16 16 M16 8 L8 16"
  }))), children);
};
export {
  OptionCard,
  OptionCardsGroup,
  useOptionCard
};
