"use client";
"use client;";
import React__default from "react";
import { Element } from "../Element/Element.js";
var _excluded = ["desktopSpan", "mobileSpan", "tabletLandscapeSpan", "tabletPortraitSpan", "isHorizontal"];
function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};
  var target = _objectWithoutPropertiesLoose(source, excluded);
  var key, i;
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }
  return target;
}
function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }
  return target;
}
var Portion = /* @__PURE__ */ React__default.forwardRef(function(_ref, ref) {
  var desktopSpan = _ref.desktopSpan, mobileSpan = _ref.mobileSpan, tabletLandscapeSpan = _ref.tabletLandscapeSpan, tabletPortraitSpan = _ref.tabletPortraitSpan, isHorizontal = _ref.isHorizontal, props = _objectWithoutProperties(_ref, _excluded);
  var classNames = [];
  if (desktopSpan || tabletLandscapeSpan || tabletPortraitSpan || mobileSpan) {
    if (desktopSpan) {
      classNames.push("".concat(desktopSpan));
    }
    if (tabletLandscapeSpan) {
      classNames.push("".concat(tabletLandscapeSpan, "-on-tablet-landscape"));
    }
    if (tabletPortraitSpan) {
      classNames.push("".concat(tabletPortraitSpan, "-on-tablet-portrait"));
    }
    if (mobileSpan) {
      classNames.push("".concat(mobileSpan, "-on-mobile"));
    }
  } else {
    classNames.push("whole");
  }
  if (isHorizontal) {
    classNames.push("horizontal");
  }
  return /* @__PURE__ */ React__default.createElement(Element, _extends({
    as: "div",
    "data-portion": true,
    ref,
    classNames
  }, props));
});
export {
  Portion
};
