"use client";
"use client;";
import React__default from "react";
import { Element } from "../Element/Element.js";
var _excluded = ["layout", "gutters", "retainLayoutOnTabletLandscape", "retainLayoutOnTabletPortrait", "retainLayoutOnMobile", "retainLayoutAlways"];
function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};
  var target = _objectWithoutPropertiesLoose(source, excluded);
  var key, i;
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }
  return target;
}
function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }
  return target;
}
var Row = /* @__PURE__ */ React__default.forwardRef(function(_ref, ref) {
  var _ref$layout = _ref.layout, layout = _ref$layout === void 0 ? "grid" : _ref$layout, _ref$gutters = _ref.gutters, gutters = _ref$gutters === void 0 ? "medium" : _ref$gutters, retainLayoutOnTabletLandscape = _ref.retainLayoutOnTabletLandscape, retainLayoutOnTabletPortrait = _ref.retainLayoutOnTabletPortrait, retainLayoutOnMobile = _ref.retainLayoutOnMobile, retainLayoutAlways = _ref.retainLayoutAlways, props = _objectWithoutProperties(_ref, _excluded);
  var classNames = [];
  if (layout) {
    classNames.push("layout-".concat(layout));
  }
  if (gutters) {
    classNames.push(gutters === "none" ? "no-gutters" : "".concat(gutters, "-gutters"));
  }
  if (retainLayoutOnTabletLandscape) {
    classNames.push("retain-layout-on-tablet-landscape");
  }
  if (retainLayoutOnTabletPortrait) {
    classNames.push("retain-layout-on-tablet-portrait");
  }
  if (retainLayoutOnMobile) {
    classNames.push("retain-layout-on-mobile");
  }
  if (retainLayoutAlways) {
    classNames.push("retain-layout-on-tablet-landscape retain-layout-on-tablet-portrait retain-layout-on-mobile");
  }
  return /* @__PURE__ */ React__default.createElement(Element, _extends({
    as: "div",
    "data-row": true,
    ref,
    classNames: [classNames.join(" ")],
    marginBottom: "tiny"
  }, props));
});
export {
  Row
};
