import React from "react";
import { CommonAndHTMLProps, ShapeTypes, SpacingTypes } from "../Element/constants";
interface CommonSkeletonProps {
    effect?: "pulse" | "wave" | "none";
    animate?: boolean;
}
interface SkeletonCustomProps extends CommonSkeletonProps {
    variant?: "line" | "circle" | "block";
    width?: string | number;
    height?: string | number;
    shape?: ShapeTypes;
}
interface SkeletonGroupCustomProps extends CommonSkeletonProps {
    repeat?: number;
    direction?: "vertical" | "horizontal";
    spacing?: SpacingTypes;
}
export type SkeletonElementType = HTMLDivElement;
export type SkeletonProps = Omit<CommonAndHTMLProps<SkeletonElementType>, keyof SkeletonCustomProps> & SkeletonCustomProps;
export type SkeletonGroupProps = Omit<CommonAndHTMLProps<SkeletonElementType>, keyof SkeletonGroupCustomProps> & SkeletonGroupCustomProps;
export declare const Skeleton: React.ForwardRefExoticComponent<Omit<CommonAndHTMLProps<HTMLDivElement>, keyof SkeletonCustomProps> & SkeletonCustomProps & React.RefAttributes<HTMLDivElement>>;
export declare const SkeletonGroup: React.ForwardRefExoticComponent<Omit<CommonAndHTMLProps<HTMLDivElement>, keyof SkeletonGroupCustomProps> & SkeletonGroupCustomProps & React.RefAttributes<HTMLDivElement>>;
export {};
