"use client";
"use client;";
import React__default, { useContext, createContext } from "react";
import { Element } from "../Element/Element.js";
function _typeof(o) {
  "@babel/helpers - typeof";
  return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function(o2) {
    return typeof o2;
  } : function(o2) {
    return o2 && "function" == typeof Symbol && o2.constructor === Symbol && o2 !== Symbol.prototype ? "symbol" : typeof o2;
  }, _typeof(o);
}
var _excluded = ["variant", "width", "height", "shape", "effect"], _excluded2 = ["effect", "spacing", "animate", "repeat", "direction", "children", "classNames"];
function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}
function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}
function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
}
function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}
function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];
  return arr2;
}
function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
function ownKeys(e, r) {
  var t = Object.keys(e);
  if (Object.getOwnPropertySymbols) {
    var o = Object.getOwnPropertySymbols(e);
    r && (o = o.filter(function(r2) {
      return Object.getOwnPropertyDescriptor(e, r2).enumerable;
    })), t.push.apply(t, o);
  }
  return t;
}
function _objectSpread(e) {
  for (var r = 1; r < arguments.length; r++) {
    var t = null != arguments[r] ? arguments[r] : {};
    r % 2 ? ownKeys(Object(t), true).forEach(function(r2) {
      _defineProperty(e, r2, t[r2]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function(r2) {
      Object.defineProperty(e, r2, Object.getOwnPropertyDescriptor(t, r2));
    });
  }
  return e;
}
function _defineProperty(obj, key, value) {
  key = _toPropertyKey(key);
  if (key in obj) {
    Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _toPropertyKey(t) {
  var i = _toPrimitive(t, "string");
  return "symbol" == _typeof(i) ? i : String(i);
}
function _toPrimitive(t, r) {
  if ("object" != _typeof(t) || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r || "default");
    if ("object" != _typeof(i)) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}
function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};
  var target = _objectWithoutPropertiesLoose(source, excluded);
  var key, i;
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }
  return target;
}
function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }
  return target;
}
var SkeletonContext = /* @__PURE__ */ createContext({
  effect: "wave",
  animate: true
});
var Skeleton = /* @__PURE__ */ React__default.forwardRef(function(_ref, ref) {
  var _ref$variant = _ref.variant, variant = _ref$variant === void 0 ? "line" : _ref$variant, width = _ref.width, height = _ref.height, shape = _ref.shape, localEffect = _ref.effect, props = _objectWithoutProperties(_ref, _excluded);
  var groupContext = useContext(SkeletonContext);
  var effectiveEffect = localEffect || groupContext.effect;
  var classNames = [];
  if (variant) {
    classNames.push("variant-".concat(variant));
  }
  if (shape) {
    classNames.push("shape-".concat(shape));
  }
  if (effectiveEffect) {
    classNames.push("effect-".concat(effectiveEffect));
  }
  var computedWidth = width || "100%";
  var computedHeight = variant === "circle" ? (typeof width === "number" ? "".concat(width, "px") : width) || height || "100%" : height;
  var style = _objectSpread({
    width: computedWidth,
    height: computedHeight,
    aspectRatio: variant === "circle" ? "1 / 1" : "auto"
  }, props.style);
  return /* @__PURE__ */ React__default.createElement(Element, _extends({
    as: "div",
    "data-skeleton": true,
    ref,
    classNames,
    style
  }, props));
});
var SkeletonGroup = /* @__PURE__ */ React__default.forwardRef(function(_ref2, ref) {
  var _ref2$effect = _ref2.effect, effect = _ref2$effect === void 0 ? "wave" : _ref2$effect, _ref2$spacing = _ref2.spacing, spacing = _ref2$spacing === void 0 ? "small" : _ref2$spacing, _ref2$animate = _ref2.animate, animate = _ref2$animate === void 0 ? true : _ref2$animate, _ref2$repeat = _ref2.repeat, repeat = _ref2$repeat === void 0 ? 1 : _ref2$repeat, _ref2$direction = _ref2.direction, direction = _ref2$direction === void 0 ? "vertical" : _ref2$direction, children = _ref2.children, _ref2$classNames = _ref2.classNames, classNames = _ref2$classNames === void 0 ? [] : _ref2$classNames, props = _objectWithoutProperties(_ref2, _excluded2);
  var groupClassNames = ["direction-".concat(direction), effect && "effect-".concat(effect)].concat(_toConsumableArray(classNames));
  if (spacing) {
    groupClassNames.push("spacing-".concat(spacing));
  }
  return /* @__PURE__ */ React__default.createElement(SkeletonContext.Provider, {
    value: {
      effect,
      animate
    }
  }, /* @__PURE__ */ React__default.createElement(Element, _extends({
    as: "div",
    ref,
    "data-skeleton-group": true,
    classNames: groupClassNames
  }, props), Array(repeat).fill(children).map(function(child, index) {
    return /* @__PURE__ */ React__default.cloneElement(child, {
      key: index
    });
  })));
});
export {
  Skeleton,
  SkeletonGroup
};
