"use client";
"use client;";
import * as React from "react";
import React__default from "react";
import { Element } from "../../Element/Element.js";
import { Div } from "../../Element/Tags.js";
import { Text } from "../../Typography/Text.js";
import { Heading6 } from "../../Typography/Heading.js";
import { Spinner } from "../../Spinner/Spinner.js";
const SvgLeft = (props) => /* @__PURE__ */ React.createElement("svg", { viewBox: "0 0 24 24", ...props }, /* @__PURE__ */ React.createElement("path", { d: "M15.41 16.59L10.83 12l4.58-4.59L14 6l-6 6 6 6 1.41-1.41z" }));
const SvgRight = (props) => /* @__PURE__ */ React.createElement("svg", { viewBox: "0 0 24 24", ...props }, /* @__PURE__ */ React.createElement("path", { d: "M8.59 16.59L13.17 12 8.59 7.41 10 6l6 6-6 6-1.41-1.41z" }));
var _excluded = ["pageIndex", "rangeStart", "rangeEnd", "hasPreviousPage", "hasNextPage", "totalRecords", "isLoading", "loadingText", "emptyText", "onPageChange"];
function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};
  var target = _objectWithoutPropertiesLoose(source, excluded);
  var key, i;
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }
  return target;
}
function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }
  return target;
}
var TablePagination = /* @__PURE__ */ React__default.forwardRef(function(_ref, ref) {
  var pageIndex = _ref.pageIndex, rangeStart = _ref.rangeStart, rangeEnd = _ref.rangeEnd, hasPreviousPage = _ref.hasPreviousPage, hasNextPage = _ref.hasNextPage, totalRecords = _ref.totalRecords, isLoading = _ref.isLoading, loadingText = _ref.loadingText, emptyText = _ref.emptyText, handlePageChange = _ref.onPageChange, props = _objectWithoutProperties(_ref, _excluded);
  return /* @__PURE__ */ React__default.createElement(Element, _extends({
    as: "div",
    "data-table-pagination": true,
    ref
  }, props), /* @__PURE__ */ React__default.createElement(Div, {
    className: "vertically-centre-items",
    marginBottom: "none"
  }, totalRecords === 0 ? /* @__PURE__ */ React__default.createElement(Heading6, {
    marginRight: "nano"
  }, emptyText ? emptyText : "No records") : /* @__PURE__ */ React__default.createElement(Heading6, {
    marginRight: "nano"
  }, rangeStart, " – ", rangeEnd, totalRecords ? " of ".concat(totalRecords) : ""), /* @__PURE__ */ React__default.createElement(Div, {
    classNames: ["nav-icon", "".concat(pageIndex === 0 && "is-inactive")]
  }, /* @__PURE__ */ React__default.createElement(SvgLeft, {
    onClick: function onClick() {
      return pageIndex !== 0 && handlePageChange(0);
    }
  }), /* @__PURE__ */ React__default.createElement("span", null, "First page")), /* @__PURE__ */ React__default.createElement(Div, {
    classNames: ["nav-icon", "".concat(!hasPreviousPage && "is-inactive")]
  }, /* @__PURE__ */ React__default.createElement(SvgLeft, {
    onClick: function onClick() {
      return hasPreviousPage && handlePageChange(pageIndex - 1);
    }
  }), /* @__PURE__ */ React__default.createElement("span", null, "Previous")), /* @__PURE__ */ React__default.createElement(Text, {
    marginLeft: "nano",
    marginRight: "nano"
  }, pageIndex + 1), /* @__PURE__ */ React__default.createElement(Div, {
    classNames: ["nav-icon", "".concat(!hasNextPage && "is-inactive")]
  }, /* @__PURE__ */ React__default.createElement(SvgRight, {
    onClick: function onClick() {
      return hasNextPage && handlePageChange(pageIndex + 1);
    }
  }), /* @__PURE__ */ React__default.createElement("span", null, "Next")), isLoading && /* @__PURE__ */ React__default.createElement(Div, {
    marginLeft: "nano",
    className: "vertically-centre-items"
  }, /* @__PURE__ */ React__default.createElement(Spinner, null), loadingText && /* @__PURE__ */ React__default.createElement(Text, {
    size: "small",
    marginLeft: "nano"
  }, loadingText))));
});
export {
  TablePagination
};
