"use client";
"use client;";
import React__default, { useEffect } from "react";
import { Element } from "../Element/Element.js";
import { Div } from "../Element/Tags.js";
import { Divider } from "../Divider/Divider.js";
import { Text } from "../Typography/Text.js";
var _excluded = ["tabs", "additionalNavContentWrapper", "defaultActiveTab", "align"];
function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}
function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}
function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];
  return arr2;
}
function _iterableToArrayLimit(r, l) {
  var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"];
  if (null != t) {
    var e, n, i, u, a = [], f = true, o = false;
    try {
      if (i = (t = t.call(r)).next, 0 === l) ;
      else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = true) ;
    } catch (r2) {
      o = true, n = r2;
    } finally {
      try {
        if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return;
      } finally {
        if (o) throw n;
      }
    }
    return a;
  }
}
function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}
function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};
  var target = _objectWithoutPropertiesLoose(source, excluded);
  var key, i;
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }
  return target;
}
function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }
  return target;
}
var Tabs = /* @__PURE__ */ React__default.forwardRef(function(_ref, ref) {
  var tabs = _ref.tabs, additionalNavContentWrapper = _ref.additionalNavContentWrapper, defaultActiveTab = _ref.defaultActiveTab, _ref$align = _ref.align, align = _ref$align === void 0 ? "left" : _ref$align, props = _objectWithoutProperties(_ref, _excluded);
  var index = tabs.findIndex(function(tab) {
    return tab.key === defaultActiveTab;
  });
  var defaultTabIndex = index > -1 ? index : 0;
  var _React$useState = React__default.useState(tabs.length > 0 ? tabs[defaultTabIndex] : void 0), _React$useState2 = _slicedToArray(_React$useState, 2), activeTab = _React$useState2[0], setActiveTab = _React$useState2[1];
  var _React$useState3 = React__default.useState(false), _React$useState4 = _slicedToArray(_React$useState3, 2), isExiting = _React$useState4[0], setIsExiting = _React$useState4[1];
  var handleTabChange = function handleTabChange2(tab) {
    setIsExiting(true);
    setTimeout(function() {
      setIsExiting(false);
      setActiveTab(tab);
    }, 120);
  };
  useEffect(function() {
    if (tabs.length > 0) {
      var matchingTab = tabs.find(function(tab) {
        return tab.key === (activeTab === null || activeTab === void 0 ? void 0 : activeTab.key);
      });
      if (matchingTab) {
        handleTabChange(matchingTab);
      } else {
        handleTabChange(tabs[0]);
      }
    } else {
      setActiveTab(void 0);
    }
  }, [tabs]);
  return /* @__PURE__ */ React__default.createElement(Element, _extends({
    as: "div",
    "data-tabs": true,
    ref
  }, props), tabs.length > 0 && activeTab ? /* @__PURE__ */ React__default.createElement(React__default.Fragment, null, /* @__PURE__ */ React__default.createElement("nav", {
    className: "align-".concat(align)
  }, /* @__PURE__ */ React__default.createElement("ul", {
    className: "tab-labels-list"
  }, tabs.map(function(tab) {
    return /* @__PURE__ */ React__default.createElement("li", {
      key: tab.key
    }, /* @__PURE__ */ React__default.createElement(Text, {
      className: "tab-label is-clickable ".concat(tab.key === activeTab.key ? "is-active" : "", " ").concat(tab.hasAlert ? "has-alert" : ""),
      onClick: function onClick() {
        return handleTabChange(tab);
      },
      marginBottom: "none"
    }, tab.label));
  })), additionalNavContentWrapper && /* @__PURE__ */ React__default.createElement(React__default.Fragment, null, additionalNavContentWrapper)), /* @__PURE__ */ React__default.createElement(Divider, {
    kind: "secondary",
    marginTop: "none",
    marginBottom: "micro"
  }), /* @__PURE__ */ React__default.createElement(Div, {
    className: "tabs-content ".concat(isExiting ? "exiting" : "")
  }, activeTab.content)) : /* @__PURE__ */ React__default.createElement(React__default.Fragment, null));
});
export {
  Tabs
};
