"use client";
"use client;";
import React__default, { useState, useCallback, useEffect } from "react";
import { Element } from "../Element/Element.js";
var _excluded = ["currentTheme", "children"];
function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}
function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}
function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];
  return arr2;
}
function _iterableToArrayLimit(r, l) {
  var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"];
  if (null != t) {
    var e, n, i, u, a = [], f = true, o = false;
    try {
      if (i = (t = t.call(r)).next, 0 === l) ;
      else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = true) ;
    } catch (r2) {
      o = true, n = r2;
    } finally {
      try {
        if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return;
      } finally {
        if (o) throw n;
      }
    }
    return a;
  }
}
function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}
function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};
  var target = _objectWithoutPropertiesLoose(source, excluded);
  var key, i;
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }
  return target;
}
function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }
  return target;
}
var storageKey = "fictoan-theme";
var themes = ["theme-light", "theme-dark"];
var ThemeContext = /* @__PURE__ */ React__default.createContext(void 0);
var defaultContext = {
  setTheme: function setTheme(_) {
  }
};
var useTheme = function useTheme2() {
  var _React$useContext;
  return (_React$useContext = React__default.useContext(ThemeContext)) !== null && _React$useContext !== void 0 ? _React$useContext : defaultContext;
};
var getTheme = function getTheme2(key, fallback) {
  var theme;
  try {
    theme = localStorage.getItem(key) || void 0;
  } catch (e) {
  }
  return theme || fallback;
};
var ThemeProvider = /* @__PURE__ */ React__default.forwardRef(function(_ref, ref) {
  var currentTheme = _ref.currentTheme, children = _ref.children, props = _objectWithoutProperties(_ref, _excluded);
  var _useState = useState(false), _useState2 = _slicedToArray(_useState, 2), shouldRender = _useState2[0], setShouldRender = _useState2[1];
  var _React$useState = React__default.useState(function() {
    return getTheme(storageKey, "theme-light");
  }), _React$useState2 = _slicedToArray(_React$useState, 2), themeState = _React$useState2[0], setThemeState = _React$useState2[1];
  var setTheme2 = useCallback(function(newTheme) {
    if (!themes.includes(newTheme)) {
      newTheme = "theme-light";
    }
    document.documentElement.className = "";
    setThemeState("".concat(newTheme));
    document.documentElement.classList.add("".concat(newTheme));
    if (!shouldRender) {
      setShouldRender(true);
    }
    try {
      localStorage.setItem(storageKey, "".concat(newTheme));
    } catch (e) {
    }
  }, [themeState]);
  useEffect(function() {
    var theme = getTheme(storageKey, "NA");
    theme === "NA" ? setTheme2(currentTheme) : setTheme2(theme);
  }, [currentTheme]);
  return /* @__PURE__ */ React__default.createElement(ThemeContext.Provider, {
    value: {
      theme: themeState,
      setTheme: setTheme2
    }
  }, /* @__PURE__ */ React__default.createElement(Element, _extends({
    as: "div",
    "data-theme-provider": true,
    ref
  }, props), shouldRender && children));
});
export {
  ThemeProvider,
  useTheme
};
