"use client";
"use client;";
import React__default, { useState, useEffect } from "react";
import { Element } from "../../Element/Element.js";
var _excluded = ["showWhen", "children", "secondsToShowFor", "closeWhen"];
function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}
function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}
function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];
  return arr2;
}
function _iterableToArrayLimit(r, l) {
  var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"];
  if (null != t) {
    var e, n, i, u, a = [], f = true, o = false;
    try {
      if (i = (t = t.call(r)).next, 0 === l) ;
      else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = true) ;
    } catch (r2) {
      o = true, n = r2;
    } finally {
      try {
        if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return;
      } finally {
        if (o) throw n;
      }
    }
    return a;
  }
}
function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}
function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};
  var target = _objectWithoutPropertiesLoose(source, excluded);
  var key, i;
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }
  return target;
}
function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }
  return target;
}
var ToastItem = /* @__PURE__ */ React__default.forwardRef(function(_ref, ref) {
  var showWhen = _ref.showWhen, children = _ref.children, secondsToShowFor = _ref.secondsToShowFor, closeWhen = _ref.closeWhen, props = _objectWithoutProperties(_ref, _excluded);
  var classNames = [];
  var _useState = useState(showWhen !== null && showWhen !== void 0 ? showWhen : false), _useState2 = _slicedToArray(_useState, 2), isVisible = _useState2[0], setIsVisible = _useState2[1];
  useEffect(function() {
    if (showWhen) {
      setIsVisible(true);
    }
    var timer = showWhen ? setTimeout(function() {
      closeWhen === null || closeWhen === void 0 || closeWhen();
    }, (secondsToShowFor !== null && secondsToShowFor !== void 0 ? secondsToShowFor : 4) * 1e3) : void 0;
    return function() {
      timer && clearTimeout(timer);
    };
  }, [showWhen, secondsToShowFor, closeWhen]);
  var onTransitionEnd = function onTransitionEnd2() {
    if (!showWhen) setIsVisible(false);
  };
  return isVisible && /* @__PURE__ */ React__default.createElement(Element, _extends({
    as: "div",
    "data-toast-item": true,
    classNames: [].concat(classNames, [showWhen ? "visible" : ""]),
    onTransitionEnd,
    shadow: "soft"
  }, props), children);
});
export {
  ToastItem
};
